Attribute VB_Name = "Main"
'DaphneLoader - a simple Windows front-end GUI for the Daphne emulator
' (feel free to write a better one!)
' v1.0 9/5/01
' By Warren Ondras
' warren@dragons-lair-project.com
' http://daphne.rulecity.com



Dim GameListFile As String
Dim ConfigFile As String

Dim CurrentGame As String



'for launching external files in registered applications
Private Declare Function ShellExecute Lib _
     "shell32.dll" Alias "ShellExecuteA" _
     (ByVal hWnd As Long, ByVal lpOperation _
     As String, ByVal lpFile As String, ByVal _
     lpParameters As String, ByVal lpDirectory _
     As String, ByVal nShowCmd As Long) As Long


Function init() As Boolean
GameListFile = App.Path & "\DaphneLoaderInfo.ini"
ConfigFile = App.Path & "\DaphneLoaderPrefs.ini"

'populate the game list
numberofgames = Val(GetFromINI("GameList", "NumberOfGames", GameListFile))
For i = 1 To numberofgames
    MainForm.GameList.AddItem (GetFromINI("GameList", "Game" & i, GameListFile))
Next

'highlight the first entry by default
MainForm.GameList.ListIndex = 0

'populate the LD player list



End Function

Sub SetCurrentGame(GameName As String)
    CurrentGame = GameName
    
    MainForm.GamePicBox.Picture = LoadPicture()
    
    picname = GetFromINI(CurrentGame, "imagename", GameListFile)
    
    If Len(picname) > 0 Then
        PicFile = App.Path & "\images\" & picname
        If Len(Dir(PicFile)) > 0 Then MainForm.GamePicBox.Picture = LoadPicture(PicFile)
    End If
    
End Sub


Sub StartGame()

CmdLine = GetCmdLine(CurrentGame)
If CmdLine = "" Then Exit Sub 'error or user cancelled

If Len(Dir(App.Path & "\daphne.exe")) > 0 Then
    ChDir (App.Path) 'the mpeg browse button seems to make us lose this...
    ChDrive (Left$(App.Path, 1)) '...and this too...
    
  Shell (App.Path & "\daphne.exe " & CmdLine)
  '  ShellExecute 0&, vbNullString, App.Path & "daphne.exe " & CmdLine, vbNullString, _
  '      vbNullString, 1 ' 1=SW_SHOWNORMAL

Else
    MsgBox "Can't find DAPHNE.EXE -- must be in same directory as Daphne Loader.", vbOKOnly + vbCritical, "Daphne Loader Error"
End If

End Sub


Sub LaunchDaphneURL()
    'take me to the Daphne web site!
    'Shell "explorer http://daphne.rulecity.com", vbNormalFocus   'launches in IE
    ShellExecute 0&, vbNullString, "http://www.daphne-emu.com", vbNullString, _
      vbNullString, 1 ' 1=SW_SHOWNORMAL
End Sub

Sub ViewErrorLog()
    
    logfile = App.Path & "\daphne_log.txt"
    
    If Len(Dir(logfile)) > 0 Then
        ShellExecute 0&, vbNullString, logfile, vbNullString, _
        vbNullString, 1 ' 1=SW_SHOWNORMAL
    Else
        MsgBox "Can't find Daphne error log (daphne_log.txt) -- must be in same directory as Daphne Loader.", vbOKOnly + vbCritical, "Daphne Loader Error"
    End If

End Sub

Sub LaunchDocs()
   ShellExecute 0&, vbNullString, "http://www.daphne-emu.com/docs.html", vbNullString, _
      vbNullString, 1 ' 1=SW_SHOWNORMAL

'    docfile = App.Path & "\doc\docs.html"
    
'    If Len(Dir(docfile)) > 0 Then
'        ShellExecute 0&, vbNullString, docfile, vbNullString, _
'        vbNullString, 1 ' 1=SW_SHOWNORMAL
'    Else
'        MsgBox "Can't find Daphne Documentation -- " & docfile, vbOKOnly + vbCritical, "Daphne Loader Error"
'    End If


End Sub


Sub EditFile(FileName As String)
    If Len(FileName) > 0 Then
        Shell "notepad.exe " & FileName, vbNormalFocus
        
    Else
        MsgBox "Invalid path/filename specified." & docfile, vbOKOnly + vbCritical, "Daphne Loader Error"
    End If


End Sub
Sub ExitApp()
    ' no other cleanup needed AFAIK
    Unload MainForm
End Sub


Function GetCurrentGame() As String
    GetCurrentGame = CurrentGame
End Function

Public Function GetGameListFile() As String
  GetGameListFile = GameListFile
End Function

Function GetConfigFile() As String
  GetConfigFile = ConfigFile
End Function

