//interstellar.h

#ifndef INTERSTELLAR_H
#define INTERSTELLAR_H

#include "game.h"

class interstellar : public game
{
public:
	interstellar();
	void do_irq();		// does an IRQ tick
	void do_nmi();		// does an NMI tick
	Uint8 cpu_mem_read(Uint16 addr);			// memory read routine
	void cpu_mem_write(Uint16 addr, Uint8 value);		// memory write routine
	Uint8 port_read(Uint16 port);		// read from port
	void port_write(Uint16 port, Uint8 value);		// write to a port
	void input_enable(Uint8);
	void input_disable(Uint8);
	bool video_init();	// function to initalize video
	void video_shutdown();	// function to shutdown video
	void video_repaint();	// function to repaint video
	bool load_roms();

private:
	

};

#endif