/*
 * tms9128nl.h
 *
 * Copyright (C) 2001 Matt Ownby
 *
 * This file is part of DAPHNE, a laserdisc arcade game emulator
 *
 * DAPHNE is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * DAPHNE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef TMS9128NL_H
#define TMS9128NL_H

#include <SDL.h>	// to declare SDL_Color

#define TMS9128NL_OVERLAY_W 320	// width of overlay
#define TMS9128NL_OVERLAY_H 192 // height of overlay

bool tms9128nl_int_enabled();
void tms9128nl_writechar(unsigned char);
unsigned char tms9128nl_getvidmem();
void tms9128nl_setvidindex(unsigned char);
int tms9128nl_setvidmem(unsigned char);
void tms9128nl_convert_color(unsigned char, SDL_Color *);
void tms9128nl_drawchar(unsigned char, int, int);
void tms9128nl_outcommand(char *s,int col,int row);
bool tms9128nl_display_init();
void tms9128nl_display_shutdown();
void tms9128nl_display_repaint();
void tms9128nl_update_overlay();
SDL_Surface *tms9128nl_get_overlay();
Uint8 tms9128nl_get_transparent_color();
SDL_Color *tms9128nl_get_colors();

#endif
